Index: /waeup/trunk/src/waeup/browser/pages.py
===================================================================
--- /waeup/trunk/src/waeup/browser/pages.py	(revision 4857)
+++ /waeup/trunk/src/waeup/browser/pages.py	(revision 4858)
@@ -3,6 +3,8 @@
 """
 import copy
+import csv
 import grok
 import os
+import re
 import sys
 from hurry import yui
@@ -28,4 +30,9 @@
 from zope.component.interfaces import Invalid
 from zope.exceptions import DuplicationError
+from zope.session.interfaces import ISession
+
+from waeup.interfaces import IBatchProcessor
+from zope.component import getAllUtilitiesRegisteredFor
+
 
 grok.context(IWAeUPObject)
@@ -245,4 +252,5 @@
     grok.context(IDataCenter)
     grok.name('index')
+    grok.require('waeup.manageUniversity')
     title = u'Data Center'
     pnav = 0
@@ -251,4 +259,5 @@
     grok.context(IDataCenter)
     grok.name('upload')
+    grok.require('waeup.manageUniversity')
     title = u'Data Center Upload'
     pnav = 0
@@ -262,5 +271,6 @@
         try:
             filename = uploadfile.filename
-            target = os.path.join(self.context.storage, filename)
+            target = os.path.join(self.context.storage,
+                                  self.getNormalizedFileName(filename))
             open(target, 'wb').write(uploadfile.read())
         except IOError:
@@ -270,4 +280,19 @@
         self.redirect(self.url(self.context))
 
+    def getNormalizedFileName(self, filename):
+        """Build sane filename.
+
+        An uploaded file foo.csv will be stored as foo_USERNAME.csv
+        where username is the principal id of the currently logged in
+        user.
+
+        Spaces in filename are replaced by underscore.
+        """
+        username = self.request.principal.id
+        filename = filename.replace(' ', '_')
+        # Only accept typical filname chars...
+        filtered_username = ''.join(re.findall('[a-zA-Z0-9_\.\-]', username))
+        base, ext = os.path.splitext(filename)
+        return '%s_%s%s' % (base, filtered_username, ext.lower())
 
 class DataCenterImportCSVPage(WAeUPPage):
@@ -310,4 +335,292 @@
         return
 
+class DatacenterImportStep1(WAeUPPage):
+    """Manual import step 1: choose file
+    """
+    grok.context(IDataCenter)
+    grok.name('import1')
+    grok.template('datacenterimport1page')
+    grok.require('waeup.manageUniversity')
+    title = u'Process CSV file'
+    pnav = 0
+
+    def getFiles(self):
+        files = self.context.getFiles(sort='date')
+        for file in files:
+            name = file.name
+            if not name.endswith('.csv') and not name.endswith('.pending'):
+                continue
+            yield file
+    
+    def update(self, filename=None, select=None, cancel=None):
+        if cancel is not None:
+            self.flash('Import aborted')
+            self.redirect(self.url(self.context))
+            return
+        if select is not None:
+            # A filename was selected
+            session = ISession(self.request)['waeup.sirp']
+            session['import_filename'] = select
+            self.redirect(self.url(self.context, '@@import2'))
+
+class DatacenterImportStep2(WAeUPPage):
+    """Manual import step 2: choose importer
+    """
+    grok.context(IDataCenter)
+    grok.name('import2')
+    grok.template('datacenterimport2page')
+    grok.require('waeup.manageUniversity')
+    title = u'Process CSV file'
+    pnav = 0
+
+    filename = None
+    mode = 'create'
+    importer = None
+
+    def getPreviewHeader(self):
+        """Get the header fields of attached CSV file.
+        """
+        reader = csv.reader(open(self.fullpath, 'rb'))
+        return reader.next()
+    
+    def getPreviewBody(self):
+        """Get the first 5 rows of attached CSV file.
+        """
+        result = []
+        num = 0
+        for row in self.reader:
+            if num > 4:
+                break
+            num += 1
+            row = row.items()
+            # Sort fields in headerfield order
+            row = sorted(row, key=lambda k: self.reader.fieldnames.index(k[0]))
+            row = [x[1] for x in row]
+            result.append(row)
+        result.append(len(result[0]) * ['...'])
+        return result
+
+    def getImporters(self):
+        importers = getAllUtilitiesRegisteredFor(IBatchProcessor)
+        importers = [
+            dict(title=x.name, name=x.util_name) for x in importers]
+        return importers
+        
+    
+    def update(self, mode=None, importer=None,
+               back1=None, cancel=None, proceed=None):
+        session = ISession(self.request)['waeup.sirp']
+        self.filename = session.get('import_filename', None)
+        
+        if self.filename is None or back1 is not None:
+            self.redirect(self.url(self.context, '@@import1'))
+            return
+        if cancel is not None:
+            self.flash('Import aborted')
+            self.redirect(self.url(self.context))
+            return
+        self.mode = mode or session.get('import_mode', self.mode)
+        self.importer = importer or session.get('import_importer', None)
+        session['import_mode'] = self.mode
+        session['import_importer'] = self.importer
+        if proceed is not None:
+            self.redirect(self.url(self.context, '@@import3'))
+            return
+        self.fullpath = os.path.join(self.context.storage, self.filename)
+        self.reader = csv.DictReader(open(self.fullpath, 'rb'))
+
+class DatacenterImportStep3(WAeUPPage):
+    """Manual import step 3: modify header
+    """
+    grok.context(IDataCenter)
+    grok.name('import3')
+    grok.template('datacenterimport3page')
+    grok.require('waeup.manageUniversity')
+    title = u'Process CSV file'
+    pnav = 0
+
+    filename = None
+    mode = None
+    importername = None
+    
+    @property
+    def nextstep(self):
+        return self.url(self.context, '@@import4')
+
+    def getPreviewHeader(self):
+        """Get the header fields of attached CSV file.
+        """
+        reader = csv.reader(open(self.fullpath, 'rb'))
+        return reader.next()
+    
+    def getPreviewBody(self):
+        """Get the first 5 rows of attached CSV file.
+        """
+        result = []
+        num = 0
+        for row in self.reader:
+            if num > 4:
+                break
+            num += 1
+            row = row.items()
+            # Sort fields in headerfield order
+            row = sorted(row, key=lambda k: self.reader.fieldnames.index(k[0]))
+            row = [x[1] for x in row]
+            result.append(row)
+        result.append(len(result[0]) * ['...'])
+        return result
+
+    def getPossibleHeaders(self):
+        """Get the possible headers.
+
+        The headers are described as dicts {value:internal_name,
+        title:displayed_name}
+        """
+        result = [dict(title='<IGNORE COL>', value='--IGNORE--')]
+        headers = self.importer.getHeaders()
+        result.extend([dict(title=x, value=x) for x in headers])
+        return result
+
+    def getWarnings(self):
+        import sys
+        result = []
+        try:
+            self.importer.checkHeaders(self.headerfields, mode=self.mode)
+        except:
+            fatal = '%s' % sys.exc_info()[1]
+            result.append(fatal)
+        return result
+    
+    @property
+    def nextstep(self):
+        return self.url(self.context, '@@import4')
+
+    def update(self, headerfield=None, back2=None, cancel=None, proceed=None):
+        session = ISession(self.request)['waeup.sirp']
+        self.filename = session.get('import_filename', None)
+        self.mode = session.get('import_mode', None)
+        self.importername = session.get('import_importer', None)
+        
+        if None in (self.filename, self.mode, self.importername):
+            self.redirect(self.url(self.context, '@@import2'))
+            return
+        if back2 is not None:
+            self.redirect(self.url(self.context ,'@@import2'))
+            return
+        if cancel is not None:
+            self.flash('Import aborted.')
+            self.redirect(self.url(self.context))
+            return
+
+        self.fullpath = os.path.join(self.context.storage, self.filename)
+        self.headerfields = headerfield or self.getPreviewHeader()
+        session['import_headerfields'] = self.headerfields
+
+        if proceed is not None:
+            self.redirect(self.url(self.context, '@@import4'))
+            return
+        
+        self.importer = getUtility(IBatchProcessor, name=self.importername)
+        self.reader = csv.DictReader(open(self.fullpath, 'rb'))
+
+class DatacenterImportStep4(WAeUPPage):
+    """Manual import step 4: do actual import
+    """
+    grok.context(IDataCenter)
+    grok.name('import4')
+    grok.template('datacenterimport4page')
+    grok.require('waeup.manageUniversity')
+    title = u'Process CSV file'
+    pnav = 0
+
+    filename = None
+    mode = None
+    importername = None
+    headerfields = None
+    warnnum = None
+
+    def update(self, back=None, finish=None, showlog=None):
+        if finish is not None:
+            self.redirect(self.url(self.context))
+            return
+        if back is not None:
+            self.redirect(self.url(self.context, '@@import3'))
+            return
+        session = ISession(self.request)['waeup.sirp']
+        self.filename = session.get('import_filename', None)
+        self.mode = session.get('import_mode', None)
+        self.importername = session.get('import_importer', None)
+        self.headerfields = session.get('import_headerfields', None)
+        
+        if None in (self.filename, self.mode, self.importername,
+                    self.headerfields):
+            self.redirect(self.url(self.context, '@@import3'))
+            return
+
+        if showlog is not None:
+            logfilename = "%s.%s.msg" % (self.filename, self.mode)
+            session['logname'] = logfilename
+            self.redirect(self.url(self.context, '@@show'))
+            return
+            
+        self.fullpath = os.path.join(self.context.storage, self.filename)
+        self.importer = getUtility(IBatchProcessor, name=self.importername)
+        (linenum, warnings) = self.importer.doImport(
+            self.fullpath, self.headerfields, self.mode,
+            self.request.principal.id)
+        self.warn_num = len(warnings)
+        if self.warn_num:
+            self.flash('Processing of %d rows failed!' % self.warn_num)
+        self.flash('Successfully processed %s rows' % (
+                linenum - (self.warn_num)))
+
+class DatacenterLogsOverview(WAeUPPage):
+    grok.context(IDataCenter)
+    grok.name('logs')
+    grok.template('datacenterlogspage')
+    grok.require('waeup.manageUniversity')
+    title = u'Data Center Logs'
+    pnav = 0
+
+    def update(self, show=None, remove=None, logname=None, back=None):
+        session = ISession(self.request)['waeup.sirp']
+        if back is not None:
+            self.redirect(self.url(self.context))
+            return
+        if logname is not None:
+            session['logname'] = logname
+            if remove is not None:
+                fullpath = os.path.join(self.context.storage, logname)
+                try:
+                    os.unlink(fullpath)
+                    self.flash('File %s deleted.' % logname)
+                except:
+                    self.flash("Could not delete %s: " % logname)
+                    self.flash("Problem: %s" % sys.exc_info()[1])
+
+        if show is not None:
+            self.redirect(self.url(self.context, '@@show'))
+            return
+        self.files = self.context.getLogFiles()
+
+class DatacenterLogsFileview(WAeUPPage):
+    grok.context(IDataCenter)
+    grok.name('show')
+    grok.template('datacenterlogsshowfilepage')
+    grok.require('waeup.manageUniversity')
+    title = u'Show file'
+    pnav = 0
+
+    def update(self, show=None, remove=None, back=None):
+        session = ISession(self.request)['waeup.sirp']
+        logname = session.get('logname', None)
+        if back is not None or logname is None:
+            self.redirect(self.url(self.context, '@@logs'))
+            return
+        self.filename = logname
+        self.files = self.context.getLogFiles()
+        fullpath = os.path.join(self.context.storage, logname)
+        self.filecontents = open(fullpath, 'rb').read()
+
 class DatacenterSettings(WAeUPPage):
     grok.context(IDataCenter)
@@ -317,5 +630,4 @@
     title = u'Data Center Settings'
     pnav = 0
-    #grok.template('master')
 
     def update(self, newpath=None, move=False, overwrite=False,
Index: /waeup/trunk/src/waeup/browser/viewlets.py
===================================================================
--- /waeup/trunk/src/waeup/browser/viewlets.py	(revision 4857)
+++ /waeup/trunk/src/waeup/browser/viewlets.py	(revision 4858)
@@ -369,5 +369,33 @@
     target = 'addcertificatecourse'
 
-
+#
+# Actions with a 'browse' icon...
+#
+class BrowseActionButton(ActionButton):
+    grok.baseclass()
+    grok.context(IWAeUPObject)
+    grok.template('actionbutton')
+    grok.viewletmanager(ActionBar)
+    grok.require('waeup.manageUniversity')
+    icon = 'actionicon_manage.png' # File must exist in static/
+    target = '@@show' # link to this viewname.
+    text = 'Show batch logs' # Text to display on the button
+
+class BrowseDatacenterLogs(BrowseActionButton):
+    grok.context(IDataCenter)
+    grok.view(DatacenterPage)
+    grok.order(4)
+    icon = 'documentinfo_templet.png'
+    target = '@@logs'
+    text = 'Show batch logs'
+
+class BatchOpButton(ActionButton):
+    grok.context(IDataCenter)
+    grok.view(DatacenterPage)
+    grok.order(6)
+    icon = 'actionbox_templet.png'
+    target = '@@import1'
+    text = 'Batch processing'
+    
 #
 # Primary navigation tabs (in upper left navigation bar)...
Index: /waeup/trunk/src/waeup/datacenter.py
===================================================================
--- /waeup/trunk/src/waeup/datacenter.py	(revision 4857)
+++ /waeup/trunk/src/waeup/datacenter.py	(revision 4858)
@@ -63,5 +63,5 @@
         return result
     
-    def getFiles(self):
+    def getFiles(self, sort='name'):
         """Get a list of files stored in `storage`.
 
@@ -76,6 +76,22 @@
                 continue
             result.append(DataCenterFile(fullpath))
-        return result
-
+        if sort == 'date':
+            # sort results in newest-first order...
+            result = sorted(result, key=lambda x: x.getTimeStamp(),
+                            reverse=True)
+        return result
+
+    def getLogFiles(self):
+        """Get a list of .msg files.
+        """
+        result = []
+        files = self.getFiles()
+        for file in files:
+            if not file.name.endswith('.msg'):
+                continue
+            result.append(
+                LogFile(os.path.join(self.storage, file.name)))
+        return result
+            
     def setStoragePath(self, path, move=False, overwrite=False):
         """Set the path where to store files.
@@ -179,4 +195,5 @@
         return
 
+
 class DataCenterFile(object):
     """A description of a file stored in data center.
@@ -189,4 +206,5 @@
         self.size = self.getSize()
         self.uploaddate = self.getDate()
+        self.lines = self.getLinesNumber()
 
     def getDate(self):
@@ -196,4 +214,9 @@
         return date.strftime('%c')
 
+    def getTimeStamp(self):
+        """Get a (machine readable) timestamp.
+        """
+        return os.path.getctime(self.context)
+    
     def getSize(self):
         """Get a human readable file size.
@@ -209,4 +232,57 @@
         return size
 
+    def getLinesNumber(self):
+        """Get number of lines.
+        """
+        num = 0
+        for line in open(self.context, 'rb'):
+            num += 1
+        return num
+    
+class LogFile(DataCenterFile):
+    """A description of a log file.
+    """
+    def __init__(self, context):
+        super(LogFile, self).__init__(context)
+        self._markers = dict()
+        self._parsed = False
+        self.userid = self.getUserId()
+        self.mode = self.getMode()
+        self.stats = self.getStats()
+        self.source = self.getSourcePath()
+
+    def _parseFile(self, maxline=10):
+        """Find markers in a file.
+        """
+        if self._parsed:
+            return
+        for line in open(self.context, 'rb'):
+            line = line.strip()
+            if not ':' in line:
+                continue
+            name, text = line.split(':', 1)
+            self._markers[name.lower()] = text
+        self._parsed = True
+        return
+
+    def _getMarker(self, marker):
+        marker = marker.lower()
+        if not self._parsed:
+            self._parseFile()
+        if marker in self._markers.keys():
+            return self._markers[marker]
+    
+    def getUserId(self):
+        return self._getMarker('user') or '<UNKNOWN>'
+
+    def getMode(self):
+        return self._getMarker('mode') or '<NOT SET>'
+
+    def getStats(self):
+        return self._getMarker('processed') or '<Info not avail.>'
+
+    def getSourcePath(self):
+        return self._getMarker('source') or None
+    
 class Import(object):
     """Helper class to aggregate imports and their data.
Index: /waeup/trunk/src/waeup/interfaces.py
===================================================================
--- /waeup/trunk/src/waeup/interfaces.py	(revision 4857)
+++ /waeup/trunk/src/waeup/interfaces.py	(revision 4858)
@@ -9,4 +9,9 @@
 from waeup.permissions import RoleSource
 
+class FatalCSVError(Exception):
+    """Some row could not be processed.
+    """
+    pass
+
 def SimpleWAeUPVocabulary(*terms):
     """A well-buildt vocabulary provides terms with a value, token and
@@ -21,9 +26,10 @@
        up a catalog.
     """
-    catalog = None
     def getValues(self):
-        if self.catalog is None:
-            self.catalog = getUtility(ICatalog, name='courses_catalog')
-        return list(self.catalog.searchResults(code=('', 'z*')))
+        catalog = getUtility(ICatalog, name='courses_catalog')
+        return list(catalog.searchResults(code=('', 'z*')))
+
+    def getToken(self, value):
+        return value.code
         
     def getTitle(self, value):
@@ -201,4 +207,5 @@
     review_state = schema.Choice(
         title = u'review state',
+        default = 'unchecked',
         values = ['unchecked', 'checked']
         )
@@ -348,5 +355,29 @@
         `clear_old_data` is set to True.
         """
-        
+
+class IBatchProcessor(Interface):
+    """A batch processor that handles mass-operations.
+    """
+    name = schema.TextLine(
+        title = u'Importer name'
+        )
+
+    mode = schema.Choice(
+        title = u'Import mode',
+        values = ['create', 'update', 'remove']
+        )
+    
+    def doImport(path):
+        """Read data from ``path`` and update connected object.
+        """
+
+class ISchemaTypeConverter(Interface):
+    """A converter for zope.schema.types.
+    """
+    def convert(string):
+        """Convert string to certain schema type.
+        """
+
+    
 class IUserAccount(IWAeUPObject):
     """A user account.
@@ -403,4 +434,17 @@
     """A data center file.
     """
+
+    name = schema.TextLine(
+        title = u'Filename')
+
+    size = schema.TextLine(
+        title = u'Human readable file size')
+
+    uploaddate = schema.TextLine(
+        title = u'Human readable upload datetime')
+
+    lines = schema.Int(
+        title = u'Number of lines in file')
+        
     def getDate():
         """Get creation timestamp from file in human readable form.
@@ -410,2 +454,6 @@
         """Get human readable size of file.
         """
+
+    def getLinesNumber():
+        """Get number of lines of file.
+        """
